module Main where

import Control.Applicative ((<$>))
import Data.List (intercalate)
import Development.Shake
import Development.Shake.FilePath
import Paths_fay_jquery    as FayJQuery
import Paths_happstack_fay as HappstackFay

main :: IO ()
main =
    shake shakeOptions $ do
      want ["MasterMind/Client/Main.js"]
      "MasterMind/Client/Main.js" *> \_ ->
          do fayQueryDataDir     <- liftIO $ FayJQuery.getDataDir
             happstackFayDataDir <- liftIO $ HappstackFay.getDataDir
             need [ "MasterMind/Client/Main.hs"
                  , "MasterMind/Shared/Core.hs"
                  , "Build.hs"]
             system' "fay" [ "--include", intercalate "," [fayQueryDataDir, happstackFayDataDir]
                           , "MasterMind/Client/Main.hs"
                           ]

--  "/home/stepcut/.cabal/share/fay-jquery-0.1.0.0,/home/stepcut/.cabal/share/happstack-fay-0.1.0.0"
