{-# LANGUAGE DeriveDataTypeable, NoImplicitPrelude #-}
module MasterMind.Shared.Core where

-- import AJAX
-- import FFI
import Data.Data
import ResponseType
import Prelude (Maybe, Eq, Read, Show, Int)

data Color
    = Red
    | Orange
    | Yellow
    | Green
    | Blue
    | Purple
      deriving (Eq, Read, Show, Data, Typeable)
-- instance Foreign Color

data Guess = Guess Color Color Color Color
{-
    { peg1 :: Color
    , peg2 :: Color
    , peg3 :: Color
    , peg4 :: Color
    }
-}
    deriving (Read, Show, Data, Typeable)
-- instance Foreign Guess

data ScorePeg
    = Black
    | White
    | None
      deriving (Read, Show, Data, Typeable)
-- instance Foreign ScorePeg

data Score = Score
    { score1 :: ScorePeg
    , score2 :: ScorePeg
    , score3 :: ScorePeg
    , score4 :: ScorePeg
    }
    deriving (Read, Show, Data, Typeable)
-- instance Foreign Score

data Row = Row
    { guess :: Guess
    , score :: Score
    }
    deriving (Read, Show, Data, Typeable)
-- instance Foreign Row

data Board = Board { rows ::  [Row] }
    deriving (Read, Show, Data, Typeable)
-- instance Foreign Board

data GameId = GameId { unGameId :: Int }
    deriving (Eq, Read, Show, Data, Typeable)
-- instance Foreign GameId

data Status
    = Win
    | Lose
    | Undecided
    deriving (Eq, Read, Show, Data, Typeable)
-- instance Foreign Status

data Game = Game
    { correctGuess :: Guess
    , status       :: Status
    , board        :: Board
    }
    deriving (Read, Show, Data, Typeable)
-- instance Foreign Game

data Command
    = SendGuess Guess (ResponseType (Maybe Row))
    | FetchBoard (ResponseType (Maybe Board))
    deriving (Read, Show, Data, Typeable)
-- instance Foreign Command

